import { type Handle, type RequestEvent } from "@sveltejs/kit";
import type { Client, TokenSet } from "openid-client";
import { Issuer } from "openid-client";
import type { Config, CookieNames, Empty, Paths } from "./types.js";
export declare class AriseIdConnect<SessionAttributes extends Empty, UserAttributes extends Empty> {
    readonly config: Config<SessionAttributes, UserAttributes>;
    readonly client: Client;
    readonly paths: Paths;
    protected cookieNames: CookieNames;
    constructor(config: Config<SessionAttributes, UserAttributes>, issuer: Issuer);
    static init<Session extends Record<never, never>, User extends Record<never, never>>(config: Config<Session, User>): Promise<AriseIdConnect<Session, User>>;
    protected getTokens(event: RequestEvent): Promise<TokenSet>;
    protected loginHandler: Handle;
    protected logoutHandler: Handle;
    protected callbackHandler: Handle;
    protected sessionHandler: Handle;
    protected miscHandler: Handle;
    handler(): Handle;
}
